using System.Security.Cryptography;
using System.Text;

namespace Hotline.Tools
{
	public static class DESExtensions
	{
		private const string key = "fwayfway";

		/// <summary>
		/// 加密
		/// </summary>
		/// <param name="text"></param>
		/// <returns></returns>
		public static string Encrypt(string text)
		{

			DESCryptoServiceProvider des = new DESCryptoServiceProvider();
			byte[] inputByteArray;
			inputByteArray = Encoding.Default.GetBytes(text);
			des.Key = ASCIIEncoding.ASCII.GetBytes(key);
			des.IV = ASCIIEncoding.ASCII.GetBytes(key);
			System.IO.MemoryStream ms = new System.IO.MemoryStream();
			CryptoStream cs = new CryptoStream(ms, des.CreateEncryptor(), CryptoStreamMode.Write);
			cs.Write(inputByteArray, 0, inputByteArray.Length);
			cs.FlushFinalBlock();
			StringBuilder ret = new StringBuilder();
			foreach (byte b in ms.ToArray())
			{
				ret.AppendFormat("{0:X2}", b);
			}
			return ret.ToString();

		}

		/// <summary>
		/// 解密
		/// </summary>
		/// <param name="text"></param>
		/// <returns></returns>
		public static string Decrypt(string text)
		{
			DESCryptoServiceProvider des = new DESCryptoServiceProvider();
			int len;
			len = text.Length / 2;
			byte[] inputByteArray = new byte[len];
			int x, i;
			for (x = 0; x < len; x++)
			{
				i = Convert.ToInt32(text.Substring(x * 2, 2), 16);
				inputByteArray[x] = (byte)i;
			}
			des.Key = ASCIIEncoding.ASCII.GetBytes(key);
			des.IV = ASCIIEncoding.ASCII.GetBytes(key);
			System.IO.MemoryStream ms = new System.IO.MemoryStream();
			CryptoStream cs = new CryptoStream(ms, des.CreateDecryptor(), CryptoStreamMode.Write);
			cs.Write(inputByteArray, 0, inputByteArray.Length);
			cs.FlushFinalBlock();
			return Encoding.Default.GetString(ms.ToArray());

		}
	}
}
